/* codez80.c */
extern void header(char *n);
extern void nl(void);
extern char *inclib(void);
extern void initmac(void);
extern int galign(int t);
extern int intsize(void);
extern int byteoff(void);
extern void olprfix(void);
extern void col(void);
extern void comment(void);
extern void prefix(void);
extern void trailer(void);
extern void prologue(void);
extern int frame(void);
extern void gtext(void);
extern void gdata(void);
extern void gbss(void);
extern void ppubext(char *scptr);
extern void fpubext(char *scptr);
extern void onum(int num);
extern void getmem(char *sym);
extern void getloc(char *sym);
extern void putmem(char *sym);
extern void putstk(char typeobj);
extern void indirect(char typeobj);
extern void swap(void);
extern void immed(void);
extern void gpush(void);
extern void gpop(void);
extern void swapstk(void);
extern void gcall(char *sname);
extern void gret(void);
extern void callstk(void);
extern void jump(int label);
extern void testjump(int label, int ft);
extern void defbyte(void);
extern void defstorage(void);
extern void defword(void);
extern int modstk(int newstkp);
extern void gaslint(void);
extern void gasrint(void);
extern void gjcase(void);
extern void gadd(int *lval, int *lval2);
extern void gsub(void);
extern void gmult(void);
extern void gdiv(void);
extern void gmod(void);
extern void gor(void);
extern void gxor(void);
extern void gand(void);
extern void gasr(void);
extern void gasl(void);
extern void gneg(void);
extern void glneg(void);
extern void gcom(void);
extern void gbool(void);
extern void ginc(int lval[]);
extern void gdec(int lval[]);
extern void geq(void);
extern void gne(void);
extern void glt(void);
extern void gle(void);
extern void ggt(void);
extern void gge(void);
extern void gult(void);
extern void gule(void);
extern void gugt(void);
extern void guge(void);
extern void gnargs(int d);

/* error.c */
extern void error(char ptr[]);
extern void doerror(char *ptr);

/* expr.c */
extern void expression(int comma);
extern int heir1(int lval[]);
extern int heir1a(int lval[]);
extern int heir1b(int lval[]);
extern int heir1c(int lval[]);
extern int heir2(int lval[]);
extern int heir3(int lval[]);
extern int heir4(int lval[]);
extern int heir5(int lval[]);
extern int heir6(int lval[]);
extern int heir7(int lval[]);
extern int heir8(int lval[]);
extern int heir9(int lval[]);
extern int heir10(int lval[]);
extern int heir11(int lval[]);

/* function.c */
extern void newfunc(void);
extern void getarg(int t);

/* gen.c */
extern int getlabel(void);
extern void printlabel(int label);
extern void glabel(char *lab);
extern void gnlabel(int nlab);
extern char outbyte(char c);
extern void outstr(char ptr[]);
extern void tab(void);
extern void ol(char ptr[]);
extern void ot(char ptr[]);
extern void outdec(int number);
extern void store(int *lval);
extern void rvalue(int *lval);
extern void test(int label, int ft);

/* io.c */
extern int openin(char *p);
extern int openout(void);
extern void outfname(char *s);
extern void fixname(char *s);
extern int checkname(char *s);
extern void kill(void);
extern void xinline(void);
extern int inbyte(void);
extern int inchar(void);
extern int gch(void);
extern int nch(void);
extern int ch(void);
extern void pl(char *str);

/* preproc.c */
extern void doinclude(void);
extern FILE *fixiname(void);
extern void doasm(void);
extern void asmfunc(void);
extern void dodefine(void);
extern void doundef(void);
extern void preprocess(void);
extern void doifdef(int ifdef);
extern int ifline(void);
extern void noiferr(void);
extern int cpp(void);
extern char keepch(char c);
extern void defmac(char *s);
extern void addmac(void);
extern void delmac(int mp);
extern char putmac(char c);
extern int findmac(char *sname);
extern void toggle(char name, int onoff);

/* lex.c */
extern void ns(void);
extern void junk(void);
extern int endst(void);
extern void needbrack(char *str);
extern int alpha(char c);
extern int numeric(char c);
extern int an(char c);
extern int sstreq(char *str1);
extern int streq(char str1[], char str2[]);
extern int astreq(char str1[], char str2[], int len);
extern int match(char *lit);
extern int amatch(char *lit, int len);
extern void blanks(void);

/* main.c */
void FEvers(void);
void usage(void);
void parse(void);
int dodcls(int stclass);
void dumplits(void);
void dumpglbs(void);
void errorsummary(void);
char xtypeof(char *s);

/* primary.c */
extern int primary(int *lval);
extern int dbltest(int val1[], int val2[]);
extern void result(int lval[], int lval2[]);
extern int constant(int val[]);
extern int cexpr(int val[]);
extern int csimple(int val[]);
extern int cterm(int val[]);
extern int cfactor(int val[]);
extern int cprimary(int val[]);
extern int snumber(int val[]);
extern int cnumber(int val[]);
extern int pstr(int val[]);
extern int qstr(int val[]);
extern char spechar(void);
extern void callfunction(char *ptr);
extern void needlval(void);

/* sym.c */
extern void declglb(int typ, int stor);
extern void declloc(int typ, int stclass);
extern int needsub(void);
extern char *findglb(char *sname);
extern char *findloc(char *sname);
extern char *addglb(char *sname, int id, int typ, int value, int stor);
extern char *addloc(char *sname, int id, int typ, int value, int stclass);
extern int symname(char *sname);
extern void illname(void);
extern void multidef(char *sname);
extern int glint(char *syment);

/* stmt.c */
extern int statement(int func);
extern int stdecl(void);
extern int doldcls(int stclass);
extern void stst(void);
extern void compound(int func);
extern void doif(void);
extern void dowhile(void);
extern void dodo(void);
extern void dofor(void);
extern void doswitch(void);
extern void docase(void);
extern void dodefault(void);
extern void doreturn(void);
extern void dobreak(void);
extern void docont(void);
extern void dumpsw(int ws[]);

/* while.c */
extern void addwhile(int ptr[]);
extern void delwhile(void);
extern int *readwhile(void);
extern int *findwhile(void);
extern int *readswitch(void);
extern void addcase(int val);

